        program tablef
C Program rewritten and recompiled 2011 - entry of setup parameters changed
C Revision 2015 - EUNIS (replacing CORINE)and various changes for Tablefit2
        integer tmax
        parameter(ndmax=10,nfmax=5,mcmax=100,nntop=900)
        parameter(ntmax=900,nqmax=50,small=0.000001)
        parameter(mmax=300,tmax=20000,ndctmx=3000,nscrn=23)
        common/few/ianal,iscale,mdmax,nsamp
        common/dat1/ntyp
        common/dat3/nquant
        common/calc1/nb,nbb,idind,lshort
        common/ccalc1/t0,t1
        common/calc2/mclass,nclass,xlist
        common/calc3/fit,zcmpst,zwtfrq,typ,nvccom
        common/calc4/nvcsub,eunis,euntyp
        common/calc5/zesum,zwfrmx,dwfrmx,dwtfrq
        common/calc6/desum,dsat
        common/captab/samout,lstout
        common/cards/card1,card2,card3,card4
        common/convrt/nqf,cov,wgtcov,weighq,freq
        integer*2 mspec(mmax),mfreq(mmax),mcover(mmax),miid(mmax)
        integer*2 nb(ndctmx),idind(ndctmx),nqf(nqmax)
        integer*2 nbb(ndctmx)
        integer   t,tt0,tt1,ttmax,t0(ndctmx),t1(ndctmx)
        integer*2 icover(ndmax),itord(nntop)
        integer*2 mclass(ntmax,nfmax),nclass(ntmax,nfmax)
        integer*2 ntyp(tmax),nquant(tmax)
        character*1 card1(40),card2(40),card3(40),card4(40)
        character*6 typ(ntmax),typw1
        character*8 sampna
        character nvccom(ntmax)*24,nvcsub(ntmax)*16
        character eunis(ntmax)*8,euntyp(ntmax)*24
        character*9 lshort(ndctmx),short
        character*12 lstout(4)
        character*21 samout(20,3)
        character*60 xlist(nscrn)
        real cov(nqmax),weighq(nqmax),wgtcov(nqmax),fitval(nntop)
        real zesum(ntmax),zwfrmx(ntmax),dwfrmx(ntmax)
        real fit(ntmax),zcmpst(ntmax),zwtfrq(ntmax)
        real desum(ntmax),dsat(ntmax),dwtfrq(ntmax)
        real freq(nfmax),weigh(mcmax)
        data typw1/' W 1  '/
 
        call screen(xlist,nscrn)
C Set initial values of parameters
        call setsw(iswtch,iscrn,msmax)
        iscale=1
        ianal=1
        call reset
        nsamp=1
C Read in and sort dictionary
        call clear
        print 2233
 2233   format(1x,'Enter number of fitted communities to be output')
        ntop=5
        call getnum(ntop,1,99)
        print 2005
 2005 format(///1x,'Reading in dictionary from file SPECDICT.txt')
        open(unit=10,file='SPECDICT.txt',status='old',err=76)
        id=2
        idind(1)=1
        idind(2)=2
        write(short,3040)
 3040 format('NEW NAME ')
        lshort(1)=short
        write(short,3041)
 3041 format('DELETE   ')
        lshort(2)=short
   50   continue
        read(10,1005,end=55) ms,short
 1005 format(i4,1x,a9)
        id=id+1
        nb(id)=ms
        nbb(id)=ms
        lshort(id)=short
        idind(id)=id
        goto 50
   55   idmax=id
        idmax1=idmax
        call isort2(nbb,idind,idmax)
        close(10)
 
C Read main data matrix and its index
        do 60 id=1,ndctmx
          t0(id)=0
          t1(id)=0
   60     continue
        print 2010
 2010 format(//1x,'Reading in association tables from file ',
     1  'ASSOCTAB.txt')
        open (unit=10,file='ASSOCTAB.txt',status='old',err=76)
        read(10,1008) ttmax,iidmax
 1008 format(3i5)
        read(10,1010) (ntyp(t),nquant(t),t=1,ttmax)
 1010 format(15(i3,i2))
 
C Calculate itmax
        itmax=0
        do 70 t=1,ttmax
          it=ntyp(t)
          if(it.gt.itmax) itmax=it
   70     continue
 
C Read in index to position
        do 74 i=1,iidmax
          read(10,1008) ms,tt0,tt1
          call ibin(nbb,idmax,ms,iid)
          if (iid.eq.0) then
               print 2020,ms
 2020 format(//1x,'Unknown species number',i6,' in data')
               call hold
               stop
               end if
          do 72 iiid=iid,idmax
               id=idind(iiid)
               if (nb(id).ne.ms) goto 74
               t0(id)=tt0
               if(ms.gt.msmax) tt1=0
               t1(id)=tt1
   72          continue
   74     continue
        close(10)
C Read in cross-reference file
        print 2037
 2037 format(//1x,'Reading cross-reference from file NVCTYPES.txt')
        open(unit=10,file='NVCTYPES.txt',status='old',err=76)
        do 90 it=1,itmax
               read(10,1020) typ(it),nvccom(it),nvcsub(it),eunis(it),
     1             euntyp(it)
 1020 format(1x,a6,1x,a24,a16,a8,a24)
   90   continue
        close(10)
        goto 100

   76 write(*,*) ' *** Error *** file not found'
      call hold
      stop

  100   continue 
C We have now read in the main data and begin calculations
        do 130 it=1,itmax
          if(typ(it).eq.typw1) iwdlim=it
C This calculates the lowest number corresponding to a woodland type
          zesum(it)=small
          zwfrmx(it)=small
          desum(it)=small
          dwtfrq(it)=0
          dwfrmx(it)=small
          do 125 nf=1,nfmax
               nclass(it,nf)=0
  125          continue
  130   continue
 
C Do calculations on datamatrix preparatory to doing same ones on samples
        call lookup(icover,ndmax,freq,nfmax,weigh,mcmax,
     1    nqf,cov,wgtcov,weighq,nqmax,small)
        ms1=0
        do 160 iid=1,idmax
          id=idind(iid)
          ms=nb(id)
          if(ms.eq.ms1) goto 160
          ms1=ms
C This avoids problem of duplicate names;  they are only used once
          call totup(id,1,1,mc,nclass,desum,ntmax,nfmax,wght,iwdlim)
  160          continue
          do 170 it=1,itmax
               zz=zwfrmx(it)
               zwfrmx(it)=zz/zesum(it)
               zesum(it)=zz
               dwfrmx(it)=dwtfrq(it)/dwfrmx(it)
  170          continue
 
C Ensure that any new species numbers are bigger than old ones
        mdmax=9000
C Read in stand and make initializations
  200   continue
        call stndin(sampna,mspec,mfreq,mcover,miid,mmax,
     1          lshort,nb,ndctmx,idmax1,idmax,imax,fmax,iswtch,msmax)
        wtsum=0.001
        nsamp=nsamp+1
        call coeffs(ianal,c1,c2,c3,c4)
        do 225 it=1,itmax
          dsat(it)=0
          dwtfrq(it)=0
          do 223 nf=1,nfmax
  223          mclass(it,nf)=0
  225     continue
          osum=small
C Work through the species in the sample
        do 260 i=1,imax
                ms=mspec(i)
                if(ms.lt.0) goto 260
  230           continue
                call ibin(nbb,idmax1,ms,iid)
                if (iid.eq.0) then
                    id=idmax1+1
                    else
                    id=idind(iid)
                    end if
                if (fmax.le.0) then
                    mf=1
                    else
                    mf=mfreq(i)
                    end if
                osum=osum+mf
                mc=mcover(i)
                if(mc.eq.0) then
                    wght=small
                    else
                    wght=weigh(mc)
                    end if
                wtsum=wtsum+wght
                call totup(id,0,mf,mc,mclass,dsat,ntmax,nfmax,wght,
     1              iwdlim)
  260           continue
        if(fmax.le.0) fmax=1
        osum=osum/fmax
C We have read in a sample;  now calculate goodness-of-fit
        do 350 it=1,itmax
          cmpsat=0
          wtfrq=small
          carryo=0
          ifull=0
          do 320 nf=nfmax,1,-1
               no=mclass(it,nf)
               if(no.eq.0.and.carryo.eq.0) goto 320
               ifull=1
               o=no/fmax
               f=freq(nf)
               e=nclass(it,nf)*f
               cmpsat=cmpsat+amin1(o+carryo,e)*f
               wtfrq=wtfrq+o*f
               carryo=amax1(0.0,o-e)
  320          continue
          if(ifull.eq.0) then
               fit(it)=0
               goto 350
               end if
          cmpsat=cmpsat/zesum(it)
          zcmpst(it)=cmpsat
          wtfrq=wtfrq/(osum*zwfrmx(it))
          if(wtfrq.gt.1.0) wtfrq=1.0
          zwtfrq(it)=wtfrq
          domsat=dsat(it)/(fmax*desum(it))
          if(domsat.gt.1.0) domsat=1.0
          dsat(it)=domsat
          ddwfrq=dwtfrq(it)/(wtsum*dwfrmx(it))
          if(ddwfrq.gt.1.0) ddwfrq=1.0
          dwtfrq(it)=ddwfrq
C We now adjust the values to take account of balance between them
          if (ianal.ge.4) goto 340
          cmpsat=cmpsat*wtfrq*(2-wtfrq)
          domsat=domsat*ddwfrq*(2-ddwfrq)
          if (wtfrq.gt.cmpsat) wtfrq=cmpsat
          if (ddwfrq.gt.domsat) ddwfrq=domsat
  340     continue
          fit(it)=c1*cmpsat+c2*wtfrq+c3*domsat+c4*ddwfrq
  350     continue
          call topn(fit,itmax,itord,fitval,ntop)
          call outans(itord,ntop,fit,zcmpst,zwtfrq,dsat,dwtfrq,iswtch,
     1         iscrn,eunis,typ,euntyp,nvccom,nvcsub,sampna,itmax)
          goto 200
          end
 
        subroutine screen(xlist,nscrn)
C Prints out a header for TABLEFIT
        character*1 blank1,answer,lowh,caph
        character*60 xlist(nscrn)
        data blank1/' '/,lowh/'h'/,caph/'H'/
        do 20 i=1,10
   20           print *
        print 2000
 2000 format(17x,'             TABLEFIT  Version 2'//
     1       17x,'  A program to identify types of vegetation'/
     2       17x,'       by measuring goodness-of-fit to '/
     3       17x,'              association tables'///
     4       17x,'                 Written by'/
     5       17x,'               Mark Hill 1993'/
     6       17x,'         revised 1996, 2011, 2015'/)
        do 30 i=1,5
  30            print *
        print 2001
 2001 format(1x,'Press <RETURN> to continue')
        read (*,*)
        do 40 i=1,2
   40          print *
        print 2002
 2002 format(15x,'This program is copyright. It must not be distr',
     1       'ibuted'/17x,'         without permission of either'//
     2       17x,'       Centre for Ecology and Hydrology'/
     3       17x,'    or Joint Nature Conservation Committee'/)
        print 2005
 2005 format(///18x,'The association tables were taken from'/
     1       17x,'  drafts of the British National Vegetation'/
     2       17x,'   Classification (edited by John Rodwell)'//
     3       17x,'The cross-reference to the EUNIS system was'/
     4       17x,'       prepared specially by Mark Hill')
       do 50 i=1,5
   50          print *
   60   print 2003
 2003 format(1x,'Press <RETURN> to continue, or type H for help')
        answer=blank1
        read (*,1000) answer
 1000 format(a1)
        if (answer.eq.blank1) return
        if (answer.eq.caph.or.answer.eq.lowh) goto 70
        goto 60
   70   call helpsc(xlist,nscrn)
        return
        end
 
        subroutine helpsc(xlist,nscrn)
C Prints out hints on running program, a screen of nscrn lines at a time
       character*60 x,xlist(nscrn),blnk60
       character*1  card(80),blank1
       equivalence  (x,card(1))
       data blank1/' '/
 
       open (unit=10,file='HELP.txt',status='old',err=999)
       do 20 ic=1,60
   20          card(ic)=blank1
       blnk60=x
   25  do 30 il=1,nscrn
               xlist(il)=blnk60
   30          continue
       read(10,1000,end=40) (xlist(ic),ic=1,nscrn)
 1000 format(a60)
       iend=0
       goto 50
   40  iend=1
   50  continue
       print 2000,(xlist(ic),ic=1,nscrn)
 2000 format(10x,a60)
       print 2001
 2001 format (1x,'Press <RETURN> to continue')
       read (*,*)
       if (iend.eq.0) goto 25
       close(10)
       return
  999  continue
       write(*,*)' *** File HELP.txt is not available ***'
       return
       end
 
        subroutine lookup(icover,ndmax,freq,nfmax,weigh,mcmax,
     1    nqf,cov,wgtcov,weighq,nqmax,small)
C Sets up look-up tables for reference later in program
        integer*2 icover(ndmax),nqf(nqmax)
        real freq(nfmax),weigh(mcmax),cov(nqmax),wgtcov(nqmax)
        real weighq(nqmax)
 
C Conversion scale from Domin to cover % (Currall 1987)
        do 22 nd=1,10
                icover(nd)=ifix((nd**2.6)/4.0)
   22           continue
 
C Conversion scale from constancy classes to estimated frequency
        freq(1)=0.12
        freq(2)=0.25
        freq(3)=0.5
        freq(4)=0.75
        freq(5)=0.95
C Set up weights for cover values
        do 30 mc=1,mcmax
          amc=mc
   30     weigh(mc)=amc**0.75
 
C Set up look-up tables for quantitative data
        do 40 nq=1,nqmax
          nf=(nq-1)/10+1
          nd=mod(nq-1,10)+1
          nqf(nq)=nf
          cov(nq)=icover(nd)/(13.0-2*nf)
          if(cov(nq).lt.2) cov(nq)=small
          f=freq(nf)
          nf=nf+nd
          wgtcov(nq)=f**2
          if(nf.eq.10) wgtcov(nq)=f
          if(nf.gt.10) wgtcov(nq)=1.0
C wgtcov is woodland weighting (to be used if it>=iwdlim)
C Weights for cover estimates are 1 if frequency+cover > 10
          weighq(nq)=cov(nq)**0.75
   40     continue
          return
          end
 
        subroutine reset
C Resets parameters
        common/few/ianal,iscale,mdmax,nsamp
 
        print 2000
 2000 format(//1x,'Set cover-abundance scale for samples')
        print 2010
 2010 format(1x,'Possible values of scale parameter are',
     1          /1x,'           1= % cover',
     2          /1x,'           2= Braun-Blanquet scale',
     3          /1x,'           3= Domin scale')
                call getnum(iscale,1,3)
 
        print 2015
 2015 format(//1x,'Set parameter to determine type of analysis')
        print 2020
 2020 format(1x,'Possible values of analysis parameter are',
     1          /12x,'1= Mixed composition and cover',
     2          /12x,'2= Species composition only',
     3          /12x,'3= Species cover only')
        print 2025
 2025 format(    12x,'4= Incomplete species list only',
     1          /12x,'5= Top few spp, descndng abndnce, no quant')
        call getnum(ianal,1,5)
        return
        end
 
          subroutine totup(id,ifirst,mf,mc,mclass,dsat,nntmax,nnfmax,
     1         wght,iwdlim)
C  This is the crucial adding-up routine.  When ifirst=1 it is used
C  to add up what is expected from NVC tables;  otherwise it is used
C  to add up values derived from a stand that has been entered.
C    mf = 1 first time through,          = mf second time through
C    mc = not needed first time through  mc defined externally
C    nclass(it,nf) first time through    mclass(it,nf) second time
C    desum(it)                           dsat(it)
C    amc = cov(nq)*f                     amc = min(cov(nq),mc)
C    wght defined internally             wght defined externally
C    dwtfrq(it) summed in same way       dwtfrq(it) summed in same way
 
        integer tmax
        parameter(ndmax=10,nfmax=5,mcmax=100)
        parameter(ntmax=900,nqmax=50,small=0.000001)
        parameter(mmax=300,tmax=20000,ndctmx=3000,nscrn=23)
        common/few/ianal,iscale,mdmax,nsamp
        common/dat1/ntyp
        common/dat3/nquant
C       common/calc1/nb,nbb,idind,lshort
        common/ccalc1/t0,t1
C       common/calc2/mclass,nclass,xlist
C       common/calc3/fit,zcmpst,zwtfrq,typ,nvccom
C       common/calc4/nvcsub,eunis,euntyp
        common/calc5/zesum,zwfrmx,dwfrmx,dwtfrq
C       common/calc6/desum,dsat
C       common/captab/samout,lstout
C       common/cards/card1,card2,card3,card4
        common/convrt/nqf,cov,wgtcov,weighq,freq
        integer*2 mclass(nntmax,nnfmax)
        real dsat(nntmax)
        integer*2 nqf(nqmax)
        integer   t,tt1,t0(ndctmx),t1(ndctmx)
        integer*2 ntyp(tmax),nquant(tmax)
        real cov(nqmax),weighq(nqmax),wgtcov(nqmax),freq(nfmax)
        real zesum(ntmax),zwfrmx(ntmax),dwfrmx(ntmax),dwtfrq(ntmax)
 
                tt1=t1(id)
                if(tt1.eq.0) return
                do 250 t=t0(id),tt1
                  it=ntyp(t)
                  nq=nquant(t)
                  nf=nqf(nq)
                  f=freq(nf)
C zesum, zwfrmx are sum of e and sum of e*f and could be calculated
C later if necessary
                  if(ifirst.eq.1) then
                         zesum(it)=zesum(it)+f
                         zwfrmx(it)=zwfrmx(it)+f*f
                         wght=weighq(nq)*f
                         dwfrmx(it)=dwfrmx(it)+wght
                         amc=cov(nq)*f
                    else
                         cmin=cov(nq)
                         amc=mc
                         if (amc.gt.cmin) amc=cmin
                    end if
                  mclass(it,nf)=mclass(it,nf)+mf
                  if(it.ge.iwdlim) then
                         dsat(it)=dsat(it)+amc*mf*wgtcov(nq)
                    else
                         dsat(it)=dsat(it)+amc*mf*f*f
                    end if
C The final *f*f is a weighting function to give extra weight to high
C constancy flasses
                  dwtfrq(it)=dwtfrq(it)+wght*f
  250             continue
                  return
                  end
 
        subroutine stndin(sampna,mspec,mfreq,mcover,miid,mmax,
     1          lshort,nb,ndctmx,idmax1,idmax,imax,fmax,iswtch,msmax)
C Reads in the next sample
 
        parameter (nc=40)
        common/few/ianal,iscale,mdmax,nsamp
        common/cards/card,ccard,x,y
 
        character*8 sampna
        integer*2 mspec(mmax),mfreq(mmax),mcover(mmax),miid(mmax)
        character*9 lshort(ndctmx),blank9,short
        integer*2 nb(ndctmx)
        character*1 card(40),ccard(40),x(40),y(40),blank1
        character*6 scale(3),sscale,crypt(3),ccrypt
        character*8 anal(5),aanal
        data blank1/' '/
        data blank9/'         '/
        data anal /'Sp & cov','Spp only','Cov only','Incmp sp',
     1         'Top few '/
        data scale/'Cover%','Br-Bla','Domin '/
        data crypt/'All sp','Nolich','Nobryo'/
 
        if (mod(iswtch,4).ge.2) then
          iprsam=1
          else
          iprsam=0
          end if
 
        if (mod(iswtch,2).eq.1) then
          iprans=1
          else
          iprans=0
          end if
C iprsam, iprans are switches to determine online printout of samples
C and answers
 
  102   if(iswtch.lt.4) then
               call clear
               print 2090
               end if
 2090 format(1x,'Now enter sample name (at most 8 characters)'/
     1       1x,'(For frequency data, follow name by * max-freq)')
        do 105 ic=1,nc
  105 card(ic)=blank1
        if (iswtch.lt.4) then
                read(*,1020) (card(ic),ic=1,nc)
                else
                if (nsamp.gt.9999) goto 999
                read(9,1020,end=999) (card(ic),ic=1,nc)
                end if
        call samfrq(card,x,nc,sampna,maxf,ierr,iswtch)
        if(ierr.eq.1) then
               if(iswtch.lt.4) goto 102
               maxf=0
               end if
        aanal=anal(ianal)
        if (msmax.eq.10000) ccrypt=crypt(1)
        if (msmax.eq.4000)  ccrypt=crypt(2)
        if (msmax.eq.3000)  ccrypt=crypt(3)
        sscale=scale(iscale)
        if(maxf.le.0) then
               print 2018,sampna,ccrypt,sscale,aanal
               write(7,2018) sampna,ccrypt,sscale,aanal
             if(iprans.eq.1) write(9,2018) sampna,ccrypt,sscale,aanal
               else
               print 2019,sampna,maxf,ccrypt,sscale,aanal
               write(7,2019) sampna,maxf,ccrypt,sscale,aanal
               if(iprans.eq.1) write(9,2019) sampna,maxf,ccrypt,
     1              sscale,aanal
               end if
 2018 format(/1x,'Sample ',a8,'       Parameters = ',a8,2(3x,a6))
 2019 format(/1x,'Sample ',a8,'*',i3,'   Parameters = ',a8,2(3x,a6))
        fmax=maxf
        i=1
        inew=0
        if(iswtch.lt.4) write(*,2020)
        if (iscale.eq.1) covlim=100.0
        if (iscale.eq.2) covlim=5.0
        if (iscale.eq.3) covlim=10.0
C This sets limits for cover values
 2020 format(1x,'Now enter species data, ending with blank line')
        do 111 ic=1,nc
  111           card(ic)=blank1
  113   if (iswtch.lt.4) then
                read(*,1020) (card(ic),ic=1,nc)
                else
                read(9,1020,end=139) (card(ic),ic=1,nc)
                end if
 1020 format(80a1)
  115   continue
        do 120 ic=1,nc
  120          ccard(ic)=card(ic)
        call destar(card,nc,nstar)
        call constr(card,y,nc,short,maxf,mf,anum,ierr)
        if (short.eq.blank9) then
                if (i.gt.1) goto 134
                if(iswtch.lt.4) write(8,2004)
                if(iprsam.eq.1) write(9,2004)
                nsamp=nsamp+1
                goto 102
                end if
        if (ierr.eq.1) goto 199
        call binfnd(lshort,idmax1,short,id,i1,i2)
                if(id.ne.0) goto 133
        do 132 id=idmax1+1,idmax
                if(short.eq.lshort(id)) goto 133
  132   continue
        iidmax=idmax
        call newnam(short,lshort,nb,id,ndctmx,idmax,idmax1,iswtch)
        if (id.eq.0) then
               ii=i-1
                if(ii.gt.0) call recap(0,ii,iswtch,mspec,
     1              mfreq,mcover,miid,lshort,idmax,maxf)
               goto 113
               end if
        inew=1
C This serves as a marker that we have emerged from newnam
        if(iidmax.ne.idmax) then
                mdmax=mdmax+1
                ms=mdmax
                nb(idmax)=ms
                endif
  133   ii=i
        ms=nb(id)+10000*nstar
        do 138 iii=1,i-1
                if(miid(iii).eq.id.and.mspec(iii).eq.ms) then
                        ii=iii
                        i=i-1
                        goto 150
                        endif
  138           continue
        mspec(ii)=ms
  150   continue
 
        mfreq(ii)=mf
        if(anum.gt.covlim) print 2990,anum,covlim
 2990 format(1x,'*** Cover value',f6.1,' greater than limit',f6.1)
        mcover(ii)=ifix(10.0*anum+0.001)
        miid(ii)=id
        if(inew.eq.1) then
               if(i.gt.0) call recap(0,i,iswtch,mspec,
     1              mfreq,mcover,miid,lshort,idmax,maxf)
               inew=0
               end if
        i=i+1
        goto 113
 
  139   nsamp=10000
C This serves as a marker that we have come to end of datafile
  134   imax=i-1
        if (ianal.eq.5) then
                iscale=1
                do 136 ii=1,imax
                        iq=70-10*ii
                        if(iq.lt.0) iq=0
                        mcover(ii)=iq*10
  136                   continue
                endif
        if(iswtch.lt.4) then
          call clear
          print 2666,sampna
          end if
 2666 format(1x,'Recap for sample ',a8/)
        call recap(1,imax,iswtch,mspec,mfreq,mcover,miid,
     1    lshort,idmax,maxf)
        if(iswtch.lt.4) then
  160          continue
               iiimax=0
                    do 165 ii=1,imax
  165                    if(mcover(ii).ge.0) iiimax=iiimax+1
               print 2777,iiimax
 2777 format(/5x,'Number of entries is ',i5)
               if(iiimax.eq.0) then
                    write (8,2004)
                    nsamp=nsamp+1
                    goto 102
                    end if
               print 2400
 2400 format(/1x,'Press <RETURN> if complete, or',
     1       /1x,'continue typing to add more data to sample'/)
               do 170 ic=1,nc
  170               card(ic)=blank1
               read(*,1020) (card(ic),ic=1,nc)
               do 172 ic=1,nc
                    if(card(ic).ne.blank1) goto 115
  172               continue
               print 2404
 2404 format(/1x,'Sample complete;  calculating goodness of fit ...')
               end if
            call recap(2,imax,iswtch,mspec,mfreq,mcover,miid,lshort,
     1         idmax,maxf)
            if(iswtch.lt.4) write(8,2004)
            if(iprsam.eq.1) write(9,2004)
 2004 format(22x)
C Finally we rescale the cover values to % cover remembering they are
C stored as 10 x their true values
        iii=0
        do 145 i=1,imax
            anum=mcover(i)
            if(anum.lt.0) goto 145
            anum=anum/10.0
            call rescal(anum,iscale,mc)
            ms=mspec(i)
  140       continue
            if(ms.gt.10000) then
               ms=ms-10000
               goto 140
               end if
            if (ms.gt.msmax) goto 145
C If necessary add together cover for layers and take maximum frequency
            do 142 iiii=1,iii
               if(mspec(iiii).eq.ms) then
                    mfreq(iiii)=max(mfreq(iiii),mfreq(i))
                    mc=mc+mcover(iiii)
                    if(mc.gt.100) mc=100
                    mcover(iiii)=mc
                    goto 145
                    end if
  142          continue
C This is a new species and no need to add layers
            iii=iii+1
            mspec(iii)=ms
            mfreq(iii)=mfreq(i)
            mcover(iii)=mc
  145          continue
        imax=iii
        return
 
  199   print 2999,(ccard(ic),ic=1,nc)
        if(iswtch.ge.4) write(7,2999) (ccard(ic),ic=1,nc)
        if(iprans.eq.1) write(9,2999) (ccard(ic),ic=1,nc)
 2999 format(5x,'*** Bad data - ignored ***   ',40a1)
        goto 113
  999   continue
        call hold
        stop
        end
 
        subroutine samfrq(card,x,nc,sampna,maxf,ierr,iswtch)
C Takes a card and reads the sample name sampna, together with any number
C after a *, which represents frequency maximum.  E.g. trial*10 would signify
C a sample called trial with frequency maximum 10.
        character*8 sampna,blank8
        character*1 card(nc),x(nc),star,blank1,letter
        character*5 scale(3),sscale,ssscal,blank5
        common/few/ianal,iscale,mdmax,nsamp
 
        data star/'*'/,blank1/' '/,blank8/'        '/,blank5/'     '/
        data scale/'COVR%','BR-BL','DOMIN'/
        maxf=0
        ierr=0
        do 50 ic=1,8
   50          x(ic)=blank1
        sscale=blank5
        ssscal=blank5
        write(sscale,3000) (card(ic),ic=14,18)
        write(ssscal,3000) (card(ic),ic=17,21)
 3000 format(5a1)
        do 60 iiscal=1,3
          if((sscale.eq.scale(iiscal).or.ssscal.eq.scale(iiscal)).
     1              and.iiscal.ne.iscale) then
                    print 2990,scale(iscale),scale(iiscal)
 2990 format(1x,'Cover scale is set to ',a5,' but input data are ',a5/
     1       1x,'Press <RETURN> to continue')
                    read(*,*)
                    call reset
                    end if
   60          continue
        do 100 ic=1,nc
               if(card(ic).eq.star) goto 200
               if(ic.gt.8) goto 100
               x(ic)=card(ic)
  100          continue
        goto 300
 
  200   ic=ic+1
        if (ic.gt.nc) goto 300
        if(card(ic).eq.blank1) goto 200
        ic1=ic
  210   ic=ic+1
        if (ic.gt.nc) goto 250
        if (card(ic).ne.blank1) goto 210
  250   ic2=ic-1
        do 285 ic=ic1,ic2
               letter=card(ic)
               read(letter,3001,err=300) num
               if(maxf.lt.1000) maxf=maxf*10+num
  285          continue
 3001 format(i1)
        if(maxf.le.100) goto 300
        print 2000
 2000 format(1x,'*** Maximum frequency may not exceed 100 ***')
  290   ierr=1
  300   write(sampna,3002) (x(ic),ic=1,8)
 3002 format(8a1)
        if(ierr.eq.1) return
        if(sampna.eq.blank8) write(sampna,3003,err=290) nsamp
 3003 format('SAMPL',i3)
        if (iswtch.lt.4) then
                if(maxf.gt.0) then
                     write(8,2001) sampna,maxf,scale(iscale)
                     else
                     write(8,2002) sampna,scale(iscale)
                     end if
                end if
        if(iswtch.eq.2.or.iswtch.eq.6) then
                if(maxf.gt.0) then
                     write(9,2003) sampna,maxf,scale(iscale)
                     else
                     write(9,2004) sampna,scale(iscale)
                     end if
                end if
 2001 format(a8,'   *',i3,1x,a5)
 2002 format(a8,5x,a5)
 2003 format(1x,a8,'   *',i3,1x,a5)
 2004 format(1x,a8,5x,a5)
        return
        end
 
        subroutine recap(iend,imax,iswtch,mspec,mfreq,
     1         mcover,miid,lshort,idmax,maxf)
C Recapitulates on contents of a sample;  if iend=0, gives only up to
C 10 last elements, otherwise gives full contents
        parameter(nrow=15,ncol=3)
        common/few/ianal,iscale,mdmax,nsamp
 
        common/captab/samout,lstout
        character*12 lstout(4)
        character*21 f,samout(20,3),blnk21
        integer*2 mspec(imax),mfreq(imax),mcover(imax),miid(imax)
        character*9 lshort(idmax),short
        character*2 strat,blank2,star1,star2
        data blank2/'  '/,star1/'* '/,star2/'**'/
        data blnk21/'                     '/
        nitem=0
        if (mod(iswtch,4).lt.2) then
               iprsam=0
               else
               iprsam=1
               end if
        do 100 irow=1,nrow
        do 100 icol=1,ncol
  100          samout(irow,icol)=blnk21
        nitmax=nrow*ncol
        imin=1
        if (iend.eq.0.and.imax.ge.10) imin=imax-9
        do 135 i=imin,imax
                ms=mspec(i)
                nstar=0
                if(ms.gt.10000) then
                        if (ms.gt.20000) then
                              nstar=2
                              else
                              nstar=1
                              end if
                        end if
                mf=mfreq(i)
                mc=mcover(i)
                if(mc.lt.0) goto 135
                id=miid(i)
                short=lshort(id)
                strat=blank2
                if (nstar.eq.1) strat=star1
                if (nstar.eq.2) strat=star2
                if (iswtch.lt.4.or.iprsam.eq.1.and.iend.eq.2)
     1              then
                    nitem=nitem+1
                    if (nitem.gt.nitmax.and.iend.eq.1) then
                         print *
                         do 120 irow=1,nrow
                           print 2005,(samout(irow,icol),icol=1,ncol)
  120                      continue
                           print 2456
                           read(*,*)
 2456 format(/1x,'Press <RETURN> for next screen of data')
                         do 125 irow=1,nrow
                         do 125 icol=1,ncol
  125                         samout(irow,icol)=blnk21
                         nitem=1
                         end if
                         f=blnk21
                    if (mod(mc,10).ne.0) then
                         anum=mc/10.0
                         if (maxf.le.0) then
                      if(iend.eq.0) write(*,2001) short,strat,anum
                      if(iend.eq.1) write(f,2001) short,strat,anum
                      if(iend.eq.2) then
                       if(iswtch.lt.4) write(8,2001) short,strat,anum
                       if(iprsam.eq.1) write(9,2001) short,strat,anum
                       end if
 2001 format(1x,a9,a2,f6.1)
                           else
                      if(iend.eq.0) write(*,2002) short,strat,mf,anum
                      if(iend.eq.1) write(f,2002) short,strat,mf,anum
                      if(iend.eq.2) then
                    if(iswtch.lt.4) write(8,2002) short,strat,mf,anum
                    if(iprsam.eq.1) write(9,2002) short,strat,mf,anum
                       end if
 2002 format(1x,a9,a2,i3,f6.1)
                           end if
                         else
                         mc=mc/10
                         if (maxf.le.0) then
                           f=blnk21
                           if(iend.eq.0) write(*,2003) short,strat,mc
                           if(iend.eq.1) write(f,2003) short,strat,mc
                           if(iend.eq.2) then
                         if(iswtch.lt.4) write(8,2003) short,strat,mc
                         if(iprsam.eq.1) write(9,2003) short,strat,mc
                           end if
 2003 format(1x,a9,a2,i4)
                           else
                        if(iend.eq.0) write(*,2004) short,strat,mf,mc
                        if(iend.eq.1) write(f,2004) short,strat,mf,mc
                        if(iend.eq.2) then
                      if(iswtch.lt.4) write(8,2004) short,strat,mf,mc
                      if(iprsam.eq.1) write(9,2004) short,strat,mf,mc
 2004 format(1x,a9,a2,i3,i4,2x)
                           end if
                         end if
                       end if
                    if(iend.eq.1) then
                       icol=(nitem-1)/nrow+1
                       irow=nitem-(icol-1)*nrow
                       icol=mod(icol,3)
                       if(icol.eq.0) icol=3
                       samout(irow,icol)=f
                       end if
                    end if
                if (iend.eq.0.or.iend.eq.1) goto 135
                mspec(i)=ms
  135           continue
        nnrow=nrow
        if(nitem.lt.nrow) nnrow=nitem
        if(iend.eq.1) then
               print *
               do 140 irow=1,nnrow
                    print 2005,(samout(irow,icol),icol=1,ncol)
  140               continue
               end if
 2005 format(3(a21,4x))
        return
        end
 
        subroutine rescal(anum,iscale,iq)
C Given the cover-abundance scale iscale, converts the data value anum
C to a % cover value iq.  Codes are:  1=% cover, 2=Braun-Blanquet,
C 3=Domin
 
        if(anum.eq.0.0) then
                iq=0
                return
                endif
        if(iscale.eq.1) then
          iq=ifix(anum+0.5)
          if(iq.gt.100) iq=100
          return
          end if
        if(iscale.eq.2) then
          if (anum.gt.2) then
                anum1=25*anum-35
                 else
                anum1=15*(anum-1)
                endif
          if (anum.lt.1) anum1=0
          iq=ifix(anum1)
          if(iq.gt.100) iq=100
          return
          end if
        if(iscale.eq.3) then
          cover=(anum**2.6)/4.0
          iq=ifix(cover)
          if(iq.gt.100) iq=100
          return
          endif
        end
 
        subroutine coeffs(ianal,c1,c2,c3,c4)
C Set coefficients for various types of goodness-of-fit criteria,
C specified by parameter 'ianal'
        if(ianal.eq.1) then
          c1=0.25
          c2=0.25
          c3=0.25
          c4=0.25
        else if(ianal.eq.2) then
          c1=0.5
          c2=0.5
          c3=0.0
          c4=0.0
        else if(ianal.eq.3) then
          c1=0.0
          c2=0.0
          c3=0.5
          c4=0.5
        else if(ianal.eq.4) then
          c1=0.0
          c2=1.0
          c3=0.0
          c4=0.0
        else
          c1=0.0
          c2=0.25
          c3=0.5
          c4=0.25
        endif
        return
        end
 
        subroutine topn(fit,itmax,itord,fitval,ntop)
C Finds indexes (itord) of top items in list fit
        integer*2 itord(ntop)
        real fit(itmax),fitval(ntop)
        bigneg=-1.0E10
        do 100 itop=1,ntop
               itord(itop)=1
               fitval(itop)=bigneg
  100          continue
        do 200 it=1,itmax
               ss=fit(it)
               if (ss.le.fitval(ntop)) goto 200
               do 150 itop=1,ntop
                    if (ss.gt.fitval(itop)) then
                            iit=it
                         do 140 iitop=itop,ntop
                              iiit=itord(iitop)
                                        sss=fitval(iitop)
                              itord(iitop)=iit
                              fitval(iitop)=ss
                              iit=iiit
                              ss=sss
  140                         continue
                         goto 200
                         end if
  150               continue
 
  200          continue
        return
        end
 
        subroutine outans(itord,ntop,fit,zcmpst,zwtfrq,dsat,dwtfrq,
     1     iswtch,iscrn,eunis,typ,euntyp,nvccom,nvcsub,sampna,itmax)
C Prints out the answer and prepares for next sample
        common/few/ianal,iscale,mdmax,nsamp
        common/cards/card,ccard,x,y
        integer*2 itord(ntop)
        character*1 card(40),ccard(40),x(40),y(40),blank1,lett,r,e
        character*6 typ(itmax),ttyp,blank6
        character*8 sampna,eunis(itmax),euni,blank8
        character*24 nvccom(itmax),euntyp(itmax),nvcc,eunt,blnk24
        character*16 nvcsub(itmax),nvcs,blnk16
        character*9 rating,ratvp,ratp,ratf,ratg,ratvg
        real fit(itmax),zcmpst(itmax),zwtfrq(itmax)
        real dsat(itmax),dwtfrq(itmax)
        data ratvp/'very poor'/,ratp/'poor     '/,ratf/'fair     '/
        data ratg/'good     '/,ratvg/'very good'/
        data blank1/' '/,r/'r'/,e/'e'/,blank6/'      '/
        data blank8/'        '/,blnk16/'                '/
        data blnk24/'                        '/
 
        iprans=mod(iswtch,2)
        do 100 itop=1,ntop
          it=itord(itop)
          ttyp=typ(it)
          euni=eunis(it)
          nvcc=nvccom(it)
          eunt=euntyp(it)
          nvcs=nvcsub(it)
               if(fit(it).lt.0.0001) then
                    ttyp=blank6
                    euni=blank8
                    nvcc=blnk24
                    eunt=blnk24
                    nvcs=blnk16
                    end if
          nfitt=ifix(100.1*fit(it))
          nout1=ifix(100.1*zcmpst(it))
          nout2=ifix(100.1*zwtfrq(it))
          nout3=ifix(100.1*dsat(it))
          nout4=ifix(100.1*dwtfrq(it))
          call zerout(ianal,nout1,nout3,nout4)
          write(7,2000) euni,ttyp,nfitt,nout1,nout2,nout3,
     1         nout4,nvcc,nvcs
          if(iprans.eq.1) write(9,2000) euni,ttyp,nfitt,nout1,
     1         nout2,nout3,nout4,nvcc,nvcs
          if (iscrn.eq.1) then
                if(itop.eq.1) then
                    if (nfitt.lt.50) then
                         rating=ratvp
                    else if (nfitt.lt.60) then
                         rating=ratp
                    else if (nfitt.lt.70) then
                         rating=ratf
                    else if (nfitt.lt.80) then
                         rating=ratg
                    else
                         rating=ratvg
                    endif
               write(*,2003) sampna,ttyp,nfitt,rating
               write(*,2004) nvcc,nvcs
               write(*,2006) eunt,euni
               write(*,2007) ntop
               endif
 2003 format(///////' NVC type of ',a8,' is ',a6,' with goodness ',
     1         'of fit ',i3,' - ',a9)
 2004 format(' NVC Community: ',a24,3x,'Subcommunity: ',a16)
 2006 format(' EUNIS        : ',a24,3x,a8)
 2007 format(////' Analysis of top',i2,' possibilities'/)
                write(*,2000) euni,ttyp,nfitt,nout1,
     1              nout2,nout3,nout4,nvcc,nvcs
                endif
 2000 format(1x,a8,a6,i3,' |',i3,3i4,'| ',a24,1x,a16)
  100     continue
 
        if(iscrn.eq.0) return
  120   write(*,2010)
 2010   format(/////1x,'Press <RETURN> to continue',
     1          /3x,'or type r to reset parameters',
     2          /3x,'or type e to exit')
        lett=blank1
        read(*,1000) lett
        call lower(lett,lett)
 1000 format(a1)
        if(lett.eq.blank1) return
        if(lett.eq.r) then
               call reset
               return
               end if
        if(lett.eq.e) then
           call hold
           stop
           end if
        goto 120
        end
 
        subroutine zerout(ianal,nout1,nout3,nout4)
C Adjusts output so that zeros appear in columns with zero coefficients
        if (ianal.eq.2) then
               nout3=0
               nout4=0
               end if
        if (ianal.eq.3) then
               nout1=0
               nout2=0
               end if
        if (ianal.eq.4) then
               nout1=0
               nout3=0
               nout4=0
               end if
        if (ianal.eq.5) nout1=0
        return
        end
 
        subroutine ibin(ma,n,na,i)
C Searches for item na in array ma (length n), index of na is i
C i=0 if na cannot be found
 
        integer*2 ma(n)
 
        i=0
        imin=1
        iamin=ma(imin)
        imax=n
        iamax=ma(imax)
   10   continue
        if(imax-imin.le.1) then
                if(iamin.eq.na) then
                        i=imin
                        return
                        end if
                if(iamax.eq.na) i=imax
                return
                end if
        imid=(imax+imin)/2
        iamid=ma(imid)
        if (na.le.iamid) then
                imax=imid
                iamax=iamid
                goto 10
                end if
        imin=imid
        iamin=iamid
        goto 10
        end
 
        subroutine binfnd(ma,n,na,i,imax,imin)
C Searches for item na in array ma (length n), index of na is i
C i=0 if na cannot be found
        character*9 ma(n),na,iamin,iamid,iamax
        i=0
        imin=1
        iamin=ma(imin)
        imax=n
        iamax=ma(imax)
   10   continue
        if(imax-imin.le.1) then
                if(iamin.eq.na) then
                        i=imin
                        return
                        end if
                if(iamax.eq.na) i=imax
                return
                end if
        imid=(imax+imin)/2
        iamid=ma(imid)
        if (na.le.iamid) then
                imax=imid
                iamax=iamid
                goto 10
                end if
        imin=imid
        iamin=iamid
        goto 10
        end
 
      subroutine isort2(dict,type,n)
      integer*2 dict(n),djx,djjx,djjjx
      integer*2 type(n),tjx,tjjx,tjjjx
 
      do 10 i=1,n
      j=i
      djx=dict(j)
      tjx=type(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=dict(jj)
      tjjx=type(jj)
      if(djjx.gt.djx) goto 8
      if(djjx.ne.djx) goto 6
      if(tjjx.ge.tjx) goto 8
    6 dict(j)=djjx
      type(j)=tjjx
      j=jj
      goto 5
    8 dict(j)=djx
      type(j)=tjx
   10 continue
      i=n
      goto 14
   12 dict(j)=djx
      type(j)=tjx
   14 if(i.eq.1) return
      djx=dict(i)
      tjx=type(i)
      dict(i)=dict(1)
      type(i)=type(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=dict(jj)
      tjjx=type(jj)
      jjj=jj+1
      djjjx=dict(jjj)
      tjjjx=type(jjj)
      if(djjx.gt.djjjx) goto 18
      if(djjx.ne.djjjx) goto 161
      if(tjjx.ge.tjjjx) goto 18
  161 if(djx.gt.djjjx) goto 12
      if(djx.ne.djjjx) goto 162
      if(tjx.ge.tjjjx) goto 12
  162 dict(j)=djjjx
      type(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=dict(jj)
      tjjx=type(jj)
   18 if(djx.gt.djjx) goto 12
      if(djx.ne.djjx) goto 19
      if(tjx.ge.tjjx) goto 12
   19 dict(j)=djjx
      type(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end
 
          subroutine getnum(iv,ivmin,ivmax)
C Reads in a new value for iv, in range (ivmin,ivmax), but retains
C existing value if user presses <RETURN>
          character*2 blank2,x
          data blank2/'  '/
  100   continue
        print 2000,iv
 2000 format(1x,'Existing value is',i3,
     1          /1x,'Press <RETURN> to retain it, or type new value')
        x=blank2
          read(*,1000) x
 1000 format(a2)
          if(x.eq.blank2) return
          read(x,3000,err=999) iiv
 3000 format(i2)
        if(iiv.lt.ivmin.or.iiv.gt.ivmax) goto 999
          iv=iiv
          return
  999   continue
        print 2999,ivmin,ivmax
 2999 format(1x,'* Inadmissible entry *',
     1      /1x,'  Limits are  ',2i6)
          goto 100
          end
 
        subroutine constr(card,y,nc,short,maxf,mf,anum,ierr)
C Accepts input in relatively free format and tries to interpret as
C species name in 9 characters.
        character*1 card(nc),x,xx,y(nc),blank1,point,z(6),zz(6)
        character*1 zero,nine
        character*6 cnum
        character*9 short
        data blank1/' '/,point/'.'/,zero/'0'/,nine/'9'/
        ierr=0
        ireal=0
        i=0
        mf=1
        iend=40
        iiend=16
        do 10 ii=1,iiend
   10   y(ii)=blank1
   20   i=i+1
        if(i.gt.iend) goto 90
        if(card(i).eq.blank1) goto 20
        ii=1
   30   if(ii.le.4) then
               x=card(i)
               call lower(x,xx)
 
               y(ii)=xx
               end if
        i=i+1
        if(i.gt.iend) goto 90
        ii=ii+1
        if(card(i).ne.blank1) goto 30
   40   i=i+1
        if(i.gt.iend) goto 90
        if(card(i).eq.blank1) goto 40
 
        ii=6
        x=card(i)
        if (x.ge.zero.and.x.le.nine) then
               i=i-1
               goto 55
               end if
   50   if(ii.le.9) then
               x=card(i)
               call lower(x,xx)
               y(ii)=xx
               end if
        i=i+1
        if(i.gt.iend) goto 90
        ii=ii+1
        if(card(i).ne.blank1) goto 50
   55   continue
        if(maxf.gt.0) then
   60          i=i+1
               if(i.gt.iend) goto 90
               if(card(i).eq.blank1) goto 60
               j=0
   65          j=j+1
               z(j)=card(i)
               i=i+1
               if(i.gt.iend) goto 90
               if(card(i).ne.blank1) goto 65
               if(j.gt.3) goto 100
               do 66 jj=1,6
   66               zz(jj)=blank1
 
               do 67 jj=1,j
   67               zz(jj+6-j)=z(jj)
               write(cnum,2004) (zz(jj),jj=1,6)
               read(cnum,1001,err=100) mf
               if (mf.gt.maxf) ierr=1
               end if
   68   i=i+1
        if(i.gt.iend) goto 90
        if(card(i).eq.blank1) goto 68
        ii=11
   70   if(ii.le.iiend) then
                y(ii)=card(i)
                if(card(i).eq.point) ireal=1
                endif
        i=i+1
        ii=ii+1
        if(i.gt.iend) goto 100
        if(card(i).ne.blank1) goto 70
 
        igap=17-ii
        ilong=6-igap
        do 85 iii=1,ilong
   85   y(17-iii)=y(17-iii-igap)
                do 86 iii=1,igap
   86   y(10+iii)=blank1
   90   continue
        write(short,2003) (y(ii),ii=1,9)
 2003 format(9a1)
        write(cnum,2004) (y(ii),ii=11,16)
 2004 format(6a1)
        if(ireal.eq.1) goto 95
 
        read(cnum,1001,err=100) num
 1001 format(i6)
        anum=num
        return
   95   read(cnum,1002,err=100) anum
 1002   format(f6.1)
        return
  100   ierr=1
        return
        end
 
        subroutine destar(card,nc,nstar)
C Takes a card with data including possible stars.  Counts stars and
C replaces them with blanks.
 
        character*1 card(nc),star,blank
        data star/'*'/,blank/' '/
 
        nstar=0
        do 100 ic=1,nc
               if(card(ic).eq.star) then
                    nstar=nstar+1
                    card(ic)=blank
                    end if
  100          continue
        if(nstar.gt.2) nstar=2
        return
        end
 
        subroutine lower(s1,s2)
C Converts from upper to lower case
        character s1*1,s2*1,low*26,up*26
        character lowlet(26)*1,uplet(26)*1
        data low/'abcdefghijklmnopqrstuvwxyz'/
        data up /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
 
        s2=s1
        read (low,1000) (lowlet(i),i=1,26)
        read (up ,1000) (uplet(i),i=1,26)
 1000 format(26a1)
        do 100 i=1,26
                if (s1.eq.uplet(i)) s2=lowlet(i)
  100           continue
        return
        end
 
C These are the subroutines that differ in the MSDOS version.
C Here they are in standard (or in one case VAX) FORTRAN.
 
        subroutine setsw(iswtch,iscrn,msmax)
C Sets value of iswtch, which determines whether screen or file input
C Determines whether user wishes to included bryophyte data etc.
C The value iswtch is actually a compount of three values, viz.
C iswtch = 4*ifil + 2*iprsam + iprans, which ifil specifies file or
C keyboard input, iprsam specifies samples to be directed to printer
C and iprans allows answers to be directed to printer
        character*20 filein, fileout,blank20/'                    '/
        iprsam=0
        iprans=0
        call clear
        call clear
        call clear
  100   print 2077
 2077 format(//1x,'Enter files and parameters to run TABLEFIT'//////////
     1         1x,'Type name of output file for answers ',
     2            'or press <RETURN> for default')
  105   continue
        read(*,1000) fileout
 1000 format(a20)
        if(fileout.eq.blank20) then
           fileout='TABLOUT.txt'
           call filogood(fileout,7)
           goto 120
           end if   
        open(unit=7,file=fileout,status='new',err=110)
        goto 120
  110   continue
        write(*,2000) fileout
 2000 format(/'  *** ERROR *** File already exists'/
     1        ' Type another name, not ',a20)
        goto 105
  120   continue
        write(*,2060)
 2060 format(//1x,'Type 0 for input of stand data from keyboard'/1x,
     1         'Type 1 for input from existing datafile')
        ifil=0
        call getnum(ifil,0,1)
 1010 format(i1)
        if(ifil.eq.1) then 
           iscrn=0
           write(*,2062)
 2062 format(//1x,'Enter name of existing datafile'/
     1         1x,'     or press <RETURN> for default SAMP.txt')
           read(*,1000) filein
           if(filein.eq.blank20) then
              open(unit=9,file='SAMP.txt',status='old',err=123)
              goto 130
              end if
  122      continue
           open(unit=9,file=filein,status='old',err=123)
           goto 130
  123      continue
           write(*,2064)
 2064 format(/'  *** ERROR *** File does not exist'/
     1        ' Type another name')
           read(*,1000) filein
           goto 122
           else
           iscrn=1
           write(*,2065)
 2065 format(//1x,'Enter name of file with record of data entry'/
     1         1x,'     or press <RETURN> for default SAMP.txt')
           read(*,1000) fileout
           if(fileout.eq.blank20) then
              fileout='SAMP.txt'
              call filogood(fileout,8)
              goto 130
              end if
  125      continue
           open(unit=8,file=fileout,status='new',err=127)
           goto 130
  127      continue
           write(*,2066)
 2066 format(/'  *** ERROR *** File already exists'/
     1        ' Type another name')
           read(*,1000) fileout
           goto 125
           end if  

  130   continue
        iswtch = 4*ifil + 2*iprsam + iprans
        ivasc=0
 
        print 2080
 2080 format(//1x,'Type 0 for all species to be included in analysis'/
     1    1x,'Type 1 for vascular plants + bryos (excluding lichens &',
     2    ' algae)'/1x,'Type 2 to include only vascular plants')
          call getnum(ivasc,0,2)
          if (ivasc.eq.0) then
               msmax=10000
               return
               end if
          if (ivasc.eq.1) then
               msmax=4000
               return
               end if
          if (ivasc.eq.2) then
               msmax=3000
               return
               end if
          end
 
        subroutine newnam(short,lshort,nb,id,ndctmx,idmax,idmax1,
     1         iswtch)
C Comment examines dictionary critically in case where the name
C cannot be found in it
        parameter(imax=75)
        character*9 short,short1,lshort(ndctmx)
        character*4 gen4,gen14
        character*1 gen1,g,sp1,s,blank1
        integer*2 list(imax),nb(ndctmx)
        data blank1/' '/
        if(iswtch.ge.4) then
               print 2000,short
               write(7,2000) short
               if(mod(iswtch,2).eq.1) write(9,2000) short
 2000 format(5x,'*** Name not in dictionary ***  ',a9)
               goto 25
               end if
 
        print 2000,short
        print 2020
 2020 format(/5x,'Select correct name ',
     1       'from menu'/5x,'or accept as new name or delete entry')
        list(1)=1
        list(2)=2
        i=2
        read (short,1000) g,s
 1000 format(a1,4x,a1)
        read (short,1001) gen4
 1001 format(a4)
        write(short1,3000) g
 3000 format(a1,'aaaaaaaa')
        call binfnd(lshort,idmax1,short1,id,id1,iid2)
        write(short1,3001) g
 3001 format(a1,'zzzzzzzz')
        call binfnd(lshort,idmax1,short1,id,iid1,id2)
        iextra=0
   15   continue
        do 20 id=id1,id2
                short1=lshort(id)
                read(short1,1000) gen1,sp1
                read(short1,1001) gen14
                if(nb(id).gt.10000) goto 20
                if (g.eq.gen1.and.s.eq.sp1.or.
     1            gen4.eq.gen14.and.s.eq.blank1) then
                        i=i+1
                        if (i.gt.imax) then
                                print 2030
 2030 format(' *** Beware - list too long *** ')
                                i=imax
                                endif
                        list(i)=id
                        endif
   20           continue
        id1=idmax1+1
        id2=idmax
        if (iextra.eq.0) then
               iextra=1
               goto 15
               end if
        call select(list,i,lshort,idmax,id)
   25   continue
        if(iswtch.ge.4.or.id.eq.1) then
               idmax=idmax+1
               if(idmax.gt.ndctmx) idmax=ndctmx
               id=idmax
               lshort(id)=short
               return
               end if
        if(id.eq.2) then
               id=0
               return
               end if
        short=lshort(id)
        return
        end
 
          subroutine select(list,imax,lshort,idmax,id)
C Looks at a list of species names and asks user for a selection (=id)
          parameter(nrow=15,ncol=4)
          common/captab/samout,lstout
          character*12 lstout(4)
          character*21 samout(20,3)
          character*9 lshort(idmax)
          integer*2 list(imax)
          character*12 outit
 
          nnrow=nrow
          if(imax.lt.nrow) nnrow=imax
          do 100 irow=1,nnrow
                 do 50 icol=1,ncol
                    i=irow+(icol-1)*nrow
                    if(i.le.imax) then
                         nncol=icol
                         id=list(i)
                         write(outit,3000) i,lshort(id)
 3000 format(i2,1x,a9)
 
                         lstout(icol)=outit
                         end if
   50               continue
                  print 2000,(lstout(icol),icol=1,nncol)
 2000 format(2x,4(4x,a12,3x))
  100     continue
            print 2001
 2001 format(/1x,'Type number of choice')
            read(*,1000,err=999) i
 1000 format(i4)
            if (i.lt.1.or.i.gt.imax) goto 999
            id=list(i)
          return
  999     id=2
            return
            end

        subroutine filogood(fileout,iunit)
C Finds an output file name based on fileout and adding digits
        character*20 fileout,fileout1,fileout2
        character*1 f1(20),blank1/' '/,dot1/'.'/
        character*1 d(10)/'0','1','2','3','4','5','6','7','8','9'/
        character*1 t/'t'/,x/'x'/
        character*1 w(2)
        character*2 ww
        equivalence(f1,fileout1)
        equivalence(w,ww)
        fileout1=fileout
        fileout2=fileout
        if(f1(1).eq.blank1) f1(1)=t
        do k=1,99
           do i=1,14
              if(f1(i).eq.dot1.or.f1(i).eq.blank1) then
                 ii=i
                 goto 100
                 end if
              ii=14
              enddo
  100      continue
           open(unit=iunit,file=fileout,status='new',err=110)
           return
  110      continue
           if(k.lt.10) then
              f1(ii)=d(1)
              ii=ii+1
              f1(ii)=d(k+1)
              else
              write(ww,2000) k
 2000 format(i2)
              f1(ii)=w(1)
              ii=ii+1
              f1(ii)=w(2)
              end if
           ii=ii+1
           f1(ii)=dot1
           ii=ii+1
           f1(ii)=t
           ii=ii+1
           f1(ii)=x
           ii=ii+1
           f1(ii)=t
           do iii=ii+1,20
              f1(iii)=blank1
              enddo
           fileout=fileout1
           fileout1=fileout2
           enddo
        fileout=fileout2
        return
        end
 
          subroutine clear
C Prints 5 blank lines (in .exe version clears the screen)
          do 100 i=1,5
  100          print *
          end

      subroutine hold
C Asks for user input before exiting, to retain DOS window
      character*1 ch
      write(*,2000)
 2000 format(////'*** Program finished  ***'///
     1       'Press <RETURN> to exit'///
     2              '*************************')
      read(*,1000) ch
 1000 format(a1)
      return
      end
